Package com.io7m.waxmill.machines

# Class WXMPinCPU

java.lang.Object
com.io7m.waxmill.machines.WXMPinCPU

All Implemented Interfaces:
  `WXMCPUTopologyType.WXMPinCPUType`, `java.lang.Comparable<WXMCPUTopologyType.WXMPinCPUType>`

    public final class WXMPinCPU
    extends java.lang.Object
    implements WXMCPUTopologyType.WXMPinCPUType

A description of a CPU pin. The given guest CPU is pinned to the given host CPU.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `WXMPinCPU.Builder` | Builds instances of type `WXMPinCPU`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static WXMPinCPU.Builder` | `builder()` | Creates a builder for `WXMPinCPU`.
  `static WXMPinCPU` | `copyOf​(WXMCPUTopologyType.WXMPinCPUType instance)` | Creates an immutable copy of a `WXMCPUTopologyType.WXMPinCPUType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `WXMPinCPU` that have equal attribute values.
  `int` | `guestCPU()` |
  `int` | `hashCode()` | Computes a hash code from attributes: `hostCPU`, `guestCPU`.
  `int` | `hostCPU()` |
  `java.lang.String` | `toString()` | Prints the immutable value `WXMPinCPU` with attribute values.
  `WXMPinCPU` | `withGuestCPU​(int value)` | Copy the current immutable object by setting a value for the `guestCPU` attribute.
  `WXMPinCPU` | `withHostCPU​(int value)` | Copy the current immutable object by setting a value for the `hostCPU` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface com.io7m.waxmill.machines.WXMCPUTopologyType.WXMPinCPUType

  `compareTo`

- ## Method Details

  - ### hostCPU

    public int hostCPU()
    Specified by:
      `hostCPU` in interface `WXMCPUTopologyType.WXMPinCPUType`
    Returns:
      The index of the host CPU

  - ### guestCPU

    public int guestCPU()
    Specified by:
      `guestCPU` in interface `WXMCPUTopologyType.WXMPinCPUType`
    Returns:
      The index of the guest CPU

  - ### withHostCPU

    public final WXMPinCPU withHostCPU​(int value)
    Copy the current immutable object by setting a value for the `hostCPU` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for hostCPU
    Returns:
      A modified copy of the `this` object

  - ### withGuestCPU

    public final WXMPinCPU withGuestCPU​(int value)
    Copy the current immutable object by setting a value for the `guestCPU` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for guestCPU
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `WXMPinCPU` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `hostCPU`, `guestCPU`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `WXMPinCPU` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static WXMPinCPU copyOf​(WXMCPUTopologyType.WXMPinCPUType instance)
    Creates an immutable copy of a `WXMCPUTopologyType.WXMPinCPUType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable WXMPinCPU instance

  - ### builder

    public static WXMPinCPU.Builder builder()
    Creates a builder for `WXMPinCPU`.

         WXMPinCPU.builder()
            .setHostCPU(int) // required hostCPU
            .setGuestCPU(int) // required guestCPU
            .build();

    Returns:
      A new WXMPinCPU builder